//=======================================================================
//                        DE0-Nano-SoC DVI sample
//
// File:
//   fm_ddio.v
//
// Abstract:
//   ALTDDIO_OUT wrapper
//  Created:
//    12 March 2014
//======================================================================
//
// Copyright (c) 2014, Kenji Ishimaru
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//  -Redistributions of source code must retain the above copyright notice,
//   this list of conditions and the following disclaimer.
//  -Redistributions in binary form must reproduce the above copyright notice,
//   this list of conditions and the following disclaimer in the documentation
//   and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// $Id: d920a4ec77fe679f4d06b17d2efda5c8463a9ee3 $
module fm_ddio (
  input clk,
  input rst_x,
  input i_data_h,
  input i_data_l,
  output o_data_p,
  output o_data_n
);

reg r_data_h_p;
reg r_data_h_n;
reg r_data_l_p;
reg r_data_l_n;

always @(posedge clk) begin
  r_data_h_p <= i_data_h;
  r_data_l_p <= i_data_l;
  r_data_h_n <= ~i_data_h;
  r_data_l_n <= ~i_data_l;
end
 
altddio_out u_altddio_p (
  .aclr (1'b0),
  .datain_h (r_data_h_p),
  .datain_l (r_data_l_p),
  .outclock (clk),
  .dataout (o_data_p),
  .aset (1'b0),
  .oe (1'b1),
  .oe_out (),
  .outclocken (1'b1),
  .sclr (1'b0),
  .sset (1'b0)
);

defparam
  u_altddio_p.extend_oe_disable = "OFF",
  u_altddio_p.intended_device_family = "Cyclone V",
  u_altddio_p.invert_output = "OFF",
  u_altddio_p.lpm_hint = "UNUSED",
  u_altddio_p.lpm_type = "altddio_out",
  u_altddio_p.oe_reg = "UNREGISTERED",
  u_altddio_p.power_up_high = "OFF",
  u_altddio_p.width = 1;

altddio_out u_altddio_n (
  .aclr (1'b0),
  .datain_h (r_data_h_n),
  .datain_l (r_data_l_n),
  .outclock (clk),
  .dataout (o_data_n),
  .aset (1'b0),
  .oe (1'b1),
  .oe_out (),
  .outclocken (1'b1),
  .sclr (1'b0),
  .sset (1'b0)
);

defparam
  u_altddio_n.extend_oe_disable = "OFF",
  u_altddio_n.intended_device_family = "Cyclone V",
  u_altddio_n.invert_output = "OFF",
  u_altddio_n.lpm_hint = "UNUSED",
  u_altddio_n.lpm_type = "altddio_out",
  u_altddio_n.oe_reg = "UNREGISTERED",
  u_altddio_n.power_up_high = "OFF",
  u_altddio_n.width = 1;

endmodule


